<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<title>AJAX AutoSuggest</title>
<script type="text/javascript" src="getdatauser2.js"></script>


		<div id="content">
<h1>AJAX AutoSuggest</h1>
<hr />
<h2>AJAX AutoSuggest</h2>
<p>In the AJAX example below we will demonstrate how a web page can communicate 
  with a web server online as a user enters data into a web form.</p>
<hr />
<h2>Type a Name in the Box Below</h2>
<form>
  First Name:
  <input name="text" type="text" id="txt1" onkeyup="GetResult(this.value)" />
</form>
<p>AutoSuggestions: <span id="ViewResult"></span></p>
<p>This example consists of three pages:</p>
<ul>
  <li>a simple HTML form</li>
  <li>a JavaScript</li>
  <li>a PHP page</li>
</ul>
<hr />
<h2>The HTML Form</h2>
<p>This is the HTML page. It contains a simple HTML form and a link to a 
  JavaScript:</p>
<table  width="100%">
  <tbody>
    <tr>
      <td><pre>&lt;html&gt;
&lt;head&gt;
&lt;script src=&quot;examples/ex2/getdatauser.js&quot;&gt;&lt;/script&gt; 
&lt;/head&gt;</pre>
          <pre>&lt;body&gt;</pre>
          <pre>&lt;form&gt; 
First Name:
&lt;input type=&quot;text&quot; id=&quot;txtDoc&quot;
onkeyup=&quot;GetResult(this.value)&quot;&gt;
&lt;/form&gt;</pre>
          <pre>&lt;p&gt;AutoSuggestions: &lt;div id=&quot;GetResult&quot;&gt;&lt;/div&gt;&lt;/p&gt; </pre>
          <pre>&lt;/body&gt;
&lt;/html&gt;</pre>
      </td>
    </tr>
  </tbody>
</table>
<h2>Example Explained - The HTML Form</h2>
<p>As you can see, the HTML page above contains a simple HTML form with an input field called 
  &quot;txtDoc&quot;.</p>
<p>The form works like this:</p>
<ol>
  <li>An event is triggered when the user presses, and releases a key in the 
    input field</li>
  <li>When the event is triggered, a function called GetResult() is executed. </li>
  <li>Below the form is a &lt;span&gt; called &quot;ViewResult&quot;. This is used as a placeholder for 
    the return data of the GetResult() function.</li>
</ol>
<hr />
<h2>The JavaScript</h2>
<p>The JavaScript code is stored in &quot;autocomplete.js&quot; and linked to the HTML 
  document:</p>
<table  width="100%">
  <tbody>
    <tr>
      <td><pre>var xmlHttp

function GetResult(str)
{
if (str.length==0)
  { 
  document.getElementById(&quot;ViewResult&quot;).innerHTML=&quot;&quot;
  return
  }
xmlHttp=GetXmlHttpObject()
if (xmlHttp==null)
  {
  alert (&quot;Browser does not support HTTP Request&quot;)
  return
  } 
var url=&quot;examples/ex2/AutoSuggest.php&quot;
url=url+&quot;?q=&quot;+str
url=url+&quot;&amp;sid=&quot;+Math.random()
xmlHttp.onreadystatechange=stateChanged 
xmlHttp.open(&quot;GET&quot;,url,true)
xmlHttp.send(null)
} 

function stateChanged() 
{ 
if (xmlHttp.readyState==4 || xmlHttp.readyState==&quot;complete&quot;)
 { 
 document.getElementById(&quot;ViewResult&quot;).innerHTML=xmlHttp.responseText 
 } 
}</pre>
          <pre>function GetXmlHttpObject()
{
var xmlHttp=null;
try
 {
 // Firefox, Opera 8.0+, Safari
 xmlHttp=new XMLHttpRequest();
 }
catch (e)
 {
 // Internet Explorer
 try
  {
  xmlHttp=new ActiveXObject(&quot;Msxml2.XMLHTTP&quot;);
  }
 catch (e)
  {
  xmlHttp=new ActiveXObject(&quot;Microsoft.XMLHTTP&quot;);
  }
 }
return xmlHttp;
}</pre>
      </td>
    </tr>
  </tbody>
</table>
<h2>Example Explained</h2>
<p><b>The GetResult() Function</b></p>
<p>This function executes every time a character is entered in the input field.</p>
<p>If there is some input in the text field (str.length &gt; 0) the function 
  executes the following:</p>
<ol>
  <li>Defines the url (filename) to send to the server</li>
  <li>Adds a parameter (q) to the url with the content of the input field </li>
  <li>Adds a random number to prevent the server from using a cached file</li>
  <li>Calls on the GetXmlHttpObject function to create an XMLHTTP object, and tells the object to execute a function 
    called stateChanged when a change is triggered</li>
  <li>Opens the XMLHTTP object with the given url.</li>
  <li>Sends an HTTP request to the server</li>
</ol>
<p>If the input field is empty, the function simply clears the content of the 
  ViewResult placeholder.</p>
<p><b>The stateChanged() Function</b></p>
<p>This function executes every time the state of the XMLHTTP 
  object changes.</p>
<p>When the state changes to 4 (or to &quot;complete&quot;), the content of the ViewResult 
  placeholder is filled with the response text.&nbsp; </p>
<p><b>The GetXmlHttpObject() Function</b></p>
<p>AJAX applications can only run in web browsers with complete XML support.</p>
<p>The code above called a function called GetXmlHttpObject().</p>
<p>The purpose of the function is to solve the problem of creating different 
  XMLHTTP objects for different browsers.</p>
<p>This is explained in the previous chapter.</p>
<hr />
<h2>The PHP Page</h2>
<p>The server page called by the JavaScript code is a simple PHP file called &quot;AutoSuggest.php&quot;.</p>
<p>The code in the &quot;AutoSuggest.php&quot; checks an array of names and returns the 
  corresponding names to the client:</p>
<table   width="100%">
  <tbody>
    <tr>
      <td><pre><p>&lt;?php<br />
        // Fill up array with names<br />
        $a[0]=&quot;Mike&quot;;<br />
        $a[1]=&quot;John&quot;;<br />
        $a[2]=&quot;Antonio&quot;;<br />
        $a[3]=&quot;Liza&quot;;<br />
        $a[4]=&quot;Elizabeth&quot;;<br />
        $a[5]=&quot;Fiona&quot;;<br />
        $a[6]=&quot;Gunda&quot;;<br />
        $a[7]=&quot;Ivan&quot;;<br />
        $a[8]=&quot;Luis&quot;;<br />
        $a[9]=&quot;Johanna&quot;;<br />
        $a[10]=&quot;Kitty&quot;;<br />
        $a[11]=&quot;Linda&quot;;<br />
        $a[12]=&quot;Nina&quot;;<br />
        $a[13]=&quot;Auphelia&quot;;<br />
        $a[14]=&quot;Petunia&quot;;<br />
        $a[15]=&quot;Amanda&quot;;<br />
        $a[16]=&quot;Raquel&quot;;<br />
        $a[17]=&quot;Cindy&quot;;<br />
        $a[18]=&quot;Doris&quot;;<br />
        $a[19]=&quot;Eve&quot;;<br />
        $a[20]=&quot;Evita&quot;;<br />
        $a[21]=&quot;Arthur&quot;;<br />
        $a[22]=&quot;Toni&quot;;<br />
        $a[23]=&quot;Anna&quot;;<br />
        $a[24]=&quot;Violet&quot;;<br />
        $a[25]=&quot;Louis&quot;;<br />
        $a[26]=&quot;Eva&quot;;<br />
        $a[27]=&quot;Ellen&quot;;<br />
        $a[28]=&quot;Marco&quot;;<br />
        $a[29]=&quot;Vicky&quot;;</p>
        <p>//get the q parameter from URL<br />
          $q=$_GET[&quot;q&quot;];</p>
        <p>//lookup all hints from array if length of q&gt;0<br />
          if (strlen($q) &gt; 0)<br />
          {<br />
          $ret=&quot;&quot;;<br />
          for($i=0; $i&lt;count($a); $i++)<br />
          {<br />
          if (strtolower($q)==strtolower(substr($a[$i],0,strlen($q))))<br />
          {<br />
          if ($ret==&quot;&quot;)<br />
          {<br />
          $ret=$a[$i];<br />
          }<br />
          else<br />
          {<br />
          $ret=$ret.&quot; , &quot;.$a[$i];<br />
          }<br />
          }<br />
          }<br />
          }</p>
        <p>//Set output to &quot;no suggestion&quot; if no hint were found<br />
          //or to the correct values<br />
          if ($ret == &quot;&quot;)<br />
          {<br />
          $response=&quot;no suggestion&quot;;<br />
          }<br />
          else<br />
          {<br />
          $response=$ret;<br />
          }</p>
        <p>//output the response<br />
          echo $response;<br />
          ?&gt;</p>        &nbsp;</pre></td>
    </tr>
  </tbody>
</table>
<p>If there is any text sent from the JavaScript (strlen($q) &gt; 0) the following 
  happens:</p>
<ol>
  <li>Find a name matching the characters sent from the JavaScript</li>
  <li>If more than one name is found, include all names in the response string</li>
  <li>If no matching names were found, set response to &quot;no AutoSuggestion&quot;</li>
  <li>If one or more matching names were found, set response to these names</li>
  <li>The response is sent to the &quot;ViewResult&quot; placeholder</li>
</ol>
<br />
<hr />
  </div>
  
</body>
</html>
